// GSF Report
// Writen by Michael Gibson
// Under the GPL
// (c) 2007
// version 0.2.0

#include <stdio.h>
#include <string.h>

char *r_version="0.2.0";

void read_data(void);
void write_i_data(void);

char start_r[5];
char end_r[5];
char idnum[500][99];
char firstname[500][99];
char middlename[500][99];
char surname[500][99];
char sex[500][99];
char birth_date[500][99];
char birth_place[500][99];
char birth_note[500][154];
char death_date[500][99];
char death_place[500][99];
char death_note[500][154];
char burial_place[500][99];
char burial_note[500][154];
char occupation[500][99];
char education[500][99];
char religon[500][99];
char gen_note[500][154];
char t_father[500][99];
char t_mother[500][99];
char t_spouce[500][99];

int num_of_entries;
char filename[50];

int stop9;

int main(int argc, char **argv)
{

  if(argc==2){
    sprintf(filename,"%s",argv[1]);
    printf("%s = filename\n",filename);
  }
  else{
    sprintf(filename,"temp.html");
    printf("%s = filename\n",filename);
  }

  read_data();
  write_i_data();
  return(0);
}

/////////////////////////////
/// read data
/////////////////////////////
void read_data()
{
  int x=0;
  FILE *filedatap;

  filedatap=fopen("idata.gsf","r");
  printf("Input file opened....\n\n");
  do{
    x++;
    if(x==999) start_r[2] = 'F';
    fgets(start_r,9,filedatap);
    if(start_r[2]== 'F') break;
    fgets(idnum[x],54,filedatap);
    fgets(firstname[x],54,filedatap);
    fgets(middlename[x],54,filedatap);
    fgets(surname[x],54,filedatap);
    fgets(sex[x],54,filedatap);
    fgets(birth_date[x],54,filedatap);
    fgets(birth_place[x],94,filedatap);
    fgets(birth_note[x],154,filedatap);
    fgets(death_date[x],54,filedatap);
    fgets(death_place[x],94,filedatap);
    fgets(death_note[x],154,filedatap);
    fgets(burial_place[x],94,filedatap);
    fgets(burial_note[x],154,filedatap);
    fgets(education[x],94,filedatap);
    fgets(occupation[x],94,filedatap);
    fgets(religon[x],94,filedatap);
    fgets(gen_note[x],154,filedatap);
    fgets(t_father[x],20,filedatap);
    fgets(t_mother[x],20,filedatap);
    fgets(t_spouce[x],20,filedatap);
    fgets(end_r,9,filedatap);
  //012
  //EOF
    printf("%s |%s |%s |%s\n",idnum[x],firstname[x], middlename[x],surname[x]);
  }while(start_r[2] != 'F' );
  x=x-1;
  printf("\nInput file read....\nNumber of individuals read =%d\n",x);
  num_of_entries=x;
  fclose(filedatap);
  printf("Input file closed...\n");
  stop9=x;
}

/////////////////////////
/// write individual data
////////////////////////
void write_i_data()
{
  int x; 
  int loop; 
  FILE *fp; 
  fp=fopen(filename,"w+");
/// Heading
  fprintf(fp,"<html>\n"); 
  fprintf(fp,"<body bgcolor=#FFFFFF>\n"); 
  fprintf(fp,"<title>Genealogy Listing</title>\n");
/// Individual
  for(x=1;x<= num_of_entries;x++){ 
    for(loop=0;loop<=99;loop++){
        if(idnum[x][loop]=='\n')        idnum[x][loop]='\0'; 
        if(firstname[x][loop]=='\n')    firstname[x][loop]='\0';
        if(middlename[x][loop]=='\n')   middlename[x][loop]='\0'; 
        if(surname[x][loop]=='\n')      surname[x][loop]='\0';
        if(birth_date[x][loop]=='\n')   birth_date[x][loop]='\0';
        if(death_date[x][loop]=='\n')   death_date[x][loop]='\0';
     }
     for(loop=4;loop<=99;loop++){
        idnum[x][loop-4]=idnum[x][loop]; 
        firstname[x][loop-4]=firstname[x][loop];
        middlename[x][loop-4]=middlename[x][loop]; 
        sex[x][loop-4]=sex[x][loop];
        surname[x][loop-4]=surname[x][loop]; 
        birth_date[x][loop-4]=birth_date[x][loop];
        death_date[x][loop-4]=death_date[x][loop]; 
      }
     for(loop=0;loop<=99;loop++){ 
      if(idnum[x][loop]==' ') idnum[x][loop]='\0';
     }
     fprintf(fp,"Individual: %s <br />\n",idnum[x]);
     if(sex[x][0]=='F') fprintf(fp,"<img src='female.gif' /> ");
     if(sex[x][0]=='M') fprintf(fp,"<img src='male.gif' /> ");

     fprintf(fp,"%s %s %s (%s - %s)<br />\n<br />\n",firstname[x],middlename[x],surname[x],birth_date[x],death_date[x]);
  }
     fprintf(fp,"</body></html>");
}
